﻿Imports System.Reflection

Module Module1
    Sub Main()
        Dim Instanz As New Methods
        Dim Typ As System.Type = GetType(Methods)

        ' Mit CallByName 
        Console.WriteLine("------ CallByName -------")
        Console.WriteLine()

        CallByName(Instanz, "ShowValue", CallType.Method)
        CallByName(Instanz, "Value", CallType.Let, 42)
        Console.WriteLine("Ausgelesener Wert: {0}", _
            CallByName(Instanz, "Value", CallType.Get))
        Console.WriteLine("Methodenaufruf: {0}", _
            CallByName(Instanz, "Foo", CallType.Method, "Hallo, ", "Welt"))

        ' Für statische Member muss eine Instanz übergeben werden
        CallByName(Instanz, "HelloWorld", CallType.Method)

        Instanz.Value = 0

        ' Mit Type und Reflection
        Console.WriteLine()
        Console.WriteLine("------ System.Type/Reflection -------")
        Console.WriteLine()

        ' Mehthoden und Eigenschaften aufrufen
        Typ.GetMethod("HelloWorld").Invoke(Nothing, Nothing)
        Typ.GetMethod("ShowValue").Invoke(Instanz, Nothing)
        Typ.GetProperty("Value").SetValue(Instanz, 42, Nothing)
        Console.WriteLine("Ausgelesener Wert: {0}", _
            Typ.GetProperty("Value").GetValue(Instanz, Nothing))
        Console.WriteLine("Methodenaufruf: {0}", _
            Typ.GetMethod("Foo").Invoke(Instanz, _
                New Object() {"Hallo, ", "Welt"}))

        ' Alle parameterlosen, öffentlichen Subs aufrufen
        For Each Methode In Typ.GetMethods
            If Methode.GetParameters.Count = 0 And _
                Methode.IsPublic And Methode.ReturnType Is GetType(Void) Then

                Console.Write(Methode.Name & " => ")
                Methode.Invoke(Instanz, Nothing)
            End If
        Next

        Console.ReadKey()
    End Sub
End Module
